﻿#target illustrator
#targetengine ill
function selfTalk(func, args){
  var bt = new BridgeTalk();
  bt.target = BridgeTalk.appName;
  args = (args !== undefined) ? args.toSource().toString().slice(1, -1) : "";
  bt.body = func.toSource()+"("+ args +");";
  bt.send();
};

var win = new Window("palette","位置で前後");
var panel = win.add("panel", undefined, "基準点");
var selector = panel.add("dropDownList",undefined,"基準点");
selector.opts = [];
selector.opts.push(selector.add("item","上"));
selector.opts.push(selector.add("item","左"));
selector.opts.push(selector.add("item","中央"));
selector.opts.push(selector.add("item","右"));
selector.opts.push(selector.add("item","下"));
selector.opts[2].selected=true;

var buttonGroup1 = win.add("group");
var buttonGroup2 = win.add("group");
var buttonGroup3 = win.add("group");
btnT = buttonGroup1.add("button", undefined, "上を前面に");
btnL = buttonGroup2.add("button", undefined, "左を前面に");
btnR = buttonGroup2.add("button", undefined, "右を前面に");
btnB = buttonGroup3.add("button", undefined, "下を前面に");

btnT.onClick = function(){
    triger(8);
};

btnL.onClick = function(){
    triger(4);
};

btnR.onClick = function(){
    triger(6);
};

btnB.onClick = function(){
    triger(2);
};


win.show();

function triger(frontDirection){
selfTalk(function(basePoint,frontDirection){
    var selectedItems = app.activeDocument.selection;
    if(selectedItems.length == 1 && selectedItems[0].typename == "GroupItem"){
        selectedItems = selectedItems[0].pageItems;
    }
    var allLayers = getAllLayers(app.activeDocument);
    var layerObjects = [];
    for(var i=0;i<allLayers.length;i++){
        for(var j=0;j<selectedItems.length;j++){
            if(allLayers[i].zOrderPosition == selectedItems[j].layer.zOrderPosition){
                if(typeof(layerObjects[i]) == "undefined"){
                    layerObjects[i] = [];
                }
                layerObjects[i].push(selectedItems[j]);
            }
        }
    }
    for (var layerKey in layerObjects){
        /*基準点*/
        basePosition = [];
        for (var itemKey in layerObjects[layerKey]){
            tempBasePosition = {};
            tempBasePosition.key = itemKey;
            tempBasePosition.x = layerObjects[layerKey][itemKey].position[0];
            tempBasePosition.y = layerObjects[layerKey][itemKey].position[1];
            if(basePoint == 0){
                tempBasePosition.x += layerObjects[layerKey][itemKey].width/2;
            }
            if(basePoint == 1){
                tempBasePosition.y -= layerObjects[layerKey][itemKey].height/2;
            }
            if(basePoint == 2){
                tempBasePosition.x += layerObjects[layerKey][itemKey].width/2;
                tempBasePosition.y -= layerObjects[layerKey][itemKey].height/2;
            }
            if(basePoint == 3){
                tempBasePosition.x += layerObjects[layerKey][itemKey].width;
                tempBasePosition.y -= layerObjects[layerKey][itemKey].height/2;
            }
            if(basePoint == 4){
                tempBasePosition.x += layerObjects[layerKey][itemKey].width/2;
                tempBasePosition.y -= layerObjects[layerKey][itemKey].height;
            }
            basePosition.push(tempBasePosition);
        }
        /*ソート*/
        basePosition.sort(function(a,b){
            if(frontDirection == 8){
                if(a.y < b.y) return -1;
                if(a.y > b.y) return 1;
                if(a.y == b.y){
                    if(Number(a.key) < Number(b.key)) return 1;
                }
                return 0;
            }else if(frontDirection == 6){
                if(a.x < b.x) return -1;
                if(a.x > b.x) return 1;
                if(a.x == b.x){
                    if(Number(a.key) < Number(b.key)) return 1;
                }
                return 0;
            }else if(frontDirection == 4){
                if(a.x > b.x) return -1;
                if(a.x < b.x) return 1;
                if(a.x == b.x){
                    if(Number(a.key) < Number(b.key)) return 1;
                }
                return 0;
            }else{
                if(a.y > b.y) return -1;
                if(a.y < b.y) return 1;
                if(a.y == b.y){
                    if(Number(a.key) < Number(b.key)) return 1;
                }
                return 0;
            }
        });
        var minKey = basePosition[0].key;
        for (var itemKey=0;itemKey<basePosition.length;itemKey++){
            if(itemKey>0 && Number(basePosition[itemKey].key) > Number(minKey)){
                layerObjects[layerKey][basePosition[itemKey].key].move(layerObjects[layerKey][basePosition[itemKey-1].key],ElementPlacement.PLACEBEFORE);
            }else{
                minKey = basePosition[itemKey].key;
            }
        }
    }
    function getAllLayers(dl){
        var ret = [];
        var layers = dl.layers;
        for(var i=0;i<layers.length;i++){
            ret.push(layers[i]);
            if(layers[i].layers.length>0){
            ret.push(getAllLayers(layers[i]));
            }
        }
    return ret;
    }
  },
  [selector.selection.index,frontDirection]
  );
}

